#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=gfx\prog.ico
#AutoIt3Wrapper_Outfile=Feuerrad.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Feuerrad
#AutoIt3Wrapper_Res_Fileversion=1.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>

#include 'BASS\Bass.au3'

; Startup Bass
_BASS_STARTUP(@ScriptDir & '\BASS\bass.dll')
If @error Then Exit MsgBox(0, 'ERROR', 'Unable to startup Bass.' & @CRLF & @CRLF & 'Error Returned: ' & @CRLF & @TAB & @error)
; Initialize Audio
_BASS_Init(0, -1, 44100, 0, '')
If @error Then Exit MsgBox(0, 'ERROR', 'Could not initialize audio')
; Load Samples
Global $hClick = _BASS_StreamCreateFile(False, @ScriptDir & '\sound\click.mp3', 0, 0, 0)
If @error Then Exit MsgBox(0, 'ERROR', 'Could not load "click.mp3"')
Global $hBoing = _BASS_StreamCreateFile(False, @ScriptDir & '\sound\boing.mp3', 0, 0, 0)
If @error Then Exit MsgBox(0, 'ERROR', 'Could not load "boing.mp3"')
Global $hTok = _BASS_StreamCreateFile(False, @ScriptDir & '\sound\tok.mp3', 0, 0, 0)
If @error Then Exit MsgBox(0, 'ERROR', 'Could not load "tok.mp3"')
Global $hJackpot = _BASS_StreamCreateFile(False, @ScriptDir & '\sound\jackpot.mp3', 0, 0, 0)
If @error Then Exit MsgBox(0, 'ERROR', 'Could not load "jackpot.mp3"')
Global $hNewHiScore = _BASS_StreamCreateFile(False, @ScriptDir & '\sound\hiscore.mp3', 0, 0, 0)
If @error Then Exit MsgBox(0, 'ERROR', 'Could not load "hiscore.mp3"')


ProcessSetPriority(@AutoItPID, 4)

Opt('GUIOnEventMode', 1)
_GDIPlus_Startup()

Global $sTitle = 'Feuerrad'
Global $sVersion = '1.2.0.0'
Global $sDate = '20.01.2014'

Global $sAppDir = @AppDataDir & '\Feuerrad\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sHiScoreFile = $sAppDir & 'HiScore.fr', $aHiScore[100][3], $iScore = 0
If Not FileExists($sHiScoreFile) Then
	_GenerateHiScore()
Else
	_LoadHiScore()
EndIf
Global $sInifile = $sAppDir & 'Feuerrad.ini'
Global $fSound = IniRead($sInifile, 'Config', 'Sound', 'True') = 'True'

Global $hHelpGui, $idAuthor1, $idAuthor2, $sLink1, $sLink2
Global Const $iW = 600, $iH = 600, $iW2 = $iW / 2, $iH2 = $iH / 2, $iBkColor = 0xD4D4D4

Global Const $hGui = GUICreate(StringFormat('%s   v%3.3s', $sTitle, $sVersion), 1020, 625)
GUISetBkColor($iBkColor)
GUISetIcon(@ScriptDir & '\gfx\prog.ico')
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, '_StartPower')
GUISetOnEvent($GUI_EVENT_PRIMARYUP, '_StopPower')
GUISetOnEvent($GUI_EVENT_CLOSE, '_Exit')
GUISetOnEvent($GUI_EVENT_RESTORE, '_Restore')

GUICtrlCreateLabel('', 0, 0, $iW+16, $iH+26)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetState(-1, $GUI_DISABLE)
Global Const $idPic = GUICtrlCreatePic('', 8, 14, $iW, $iH)
Global Const $hPic = GUICtrlGetHandle($idPic)
Global $idSpeaker = GUICtrlCreateIcon(@ScriptDir & '\gfx\speaker1.ico', 0, 630, 10, 48, 48)
GUICtrlSetTip(-1, 'Sound ein-/ausschalten')
GUICtrlSetOnEvent(-1, '_SoundOnOff')
If $fSound Then
	GUICtrlSetImage($idSpeaker, @ScriptDir & '\gfx\speaker1.ico')
Else
	GUICtrlSetImage($idSpeaker, @ScriptDir & '\gfx\speaker0.ico')
EndIf
GUICtrlCreateIcon(@ScriptDir & '\gfx\feuerrad.ico', 0, 715, 20, 186, 32)
GUICtrlCreateIcon(@ScriptDir & '\gfx\sun.ico', 0, 950, 10, 48, 48)
GUICtrlSetTip(-1, 'Informationen ber das Programm')
GUICtrlSetOnEvent(-1, '_ShowHelp')

GUICtrlCreateIcon(@ScriptDir & '\gfx\pad.ico', 0, 626, 70, 32, 32)
GUICtrlCreateLabel('Gesamtpunkte:', 666, 80, 120, 30)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman', 4)
Global Const $idTotalScore = GUICtrlCreateLabel('0', 630, 105, 160, 34, $SS_CENTER, 0x00020000)
GUICtrlSetBkColor(-1, 0xB0F0B0)
GUICtrlSetFont(-1, 24, 800, 0, 'Courier New', 4)

Global Const $idScoreList = GUICtrlCreateListView('Runde|Punkte', 630, 145, 160, 250)
GUICtrlSetFont(-1, 12, 800, 0, 'Courier New', 4)
Global Const $hScoreList = GUICtrlGetHandle($idScoreList)
Global $aidScore[10], $iScoreCount = 0
For $i = 0 To 9
	$aidScore[$i] = GUICtrlCreateListViewItem($i + 1 & '|', $idScoreList)
Next
_GUICtrlListView_SetColumnWidth($hScoreList, 0, $LVSCW_AUTOSIZE_USEHEADER)
_GUICtrlListView_JustifyColumn($hScoreList, 0, 2)
_GUICtrlListView_SetColumnWidth($hScoreList, 1, $LVSCW_AUTOSIZE_USEHEADER)
_GUICtrlListView_JustifyColumn($hScoreList, 1, 2)

GUICtrlCreateIcon(@ScriptDir & '\gfx\top100.ico', 0, 834, 66, 63, 34)
GUICtrlCreateLabel('TOP 100:', 905, 80, 100, 30)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman', 4)
Global Const $idHiScoreList = GUICtrlCreateListView('Pl.|Pkt.|Name', 810, 105, 208, 440)
GUICtrlSetFont(-1, 10, 400, 0, 'Courier New', 4)
Global Const $hHiScoreList = GUICtrlGetHandle($idHiScoreList)
_GUICtrlListView_SetColumnWidth($hHiScoreList, 0, $LVSCW_AUTOSIZE_USEHEADER)
_GUICtrlListView_JustifyColumn($hHiScoreList, 0, 2)
_GUICtrlListView_SetColumnWidth($hHiScoreList, 1, $LVSCW_AUTOSIZE_USEHEADER)
_GUICtrlListView_JustifyColumn($hHiScoreList, 1, 1)
_GUICtrlListView_SetColumnWidth($hHiScoreList, 2, 105)
_GUICtrlListView_JustifyColumn($hHiScoreList, 2, 0)
_GUICtrlListView_AddArray($hHiScoreList, $aHiScore)
Global $hHeader = HWnd(_GUICtrlListView_GetHeader($hHiScoreList))
ControlDisable($hGui, '', $hHeader)

Global Const $idNewGame = GUICtrlCreateButton('Neues Spiel', 630, 400, 160, 36)
GUICtrlSetFont(-1, 18, 600, 0, 'Times New Roman', 4)
GUICtrlSetOnEvent(-1, '_NewGame')
GUICtrlSetState(-1, $GUI_HIDE)

Global Const $idStart = GUICtrlCreateButton(' Start' & @CRLF & '   Runde 1', 630, 440, 160, 52, 0x2000)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman', 4)
GUICtrlSetImage(-1, @ScriptDir & '\gfx\rotate.ico')

DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; auf den klassischen Style umschalten
Global Const $idStartPower = GUICtrlCreateProgress(631, 498, 158, 15)
GUICtrlSetBkColor(-1, 0xE0E0E0)
GUICtrlSetColor(-1, 0x04488FF)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; zurck zum Standard-Windowsstyle

GUICtrlCreateLabel('|', 631, 513, 50, 12)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial', 4)
GUICtrlCreateLabel('0%', 630, 525, 50, 15)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial', 4)
GUICtrlCreateLabel('|', 630 + 77, 513, 50, 12)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial', 4)
GUICtrlCreateLabel('50%', 630 + 70, 525, 50, 15)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial', 4)
GUICtrlCreateLabel('|', 630 + 156, 513, 50, 12)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial', 4)
GUICtrlCreateLabel('100%', 630 + 142, 525, 50, 15)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial', 4)

Global $aidInputGroup[4]
$aidInputGroup[0] = GUICtrlCreateGroup('Eine "TOP 100"-Platzierung! Bitte gib Deinen Namen ein:', 628, 560, 380, 60)
GUICtrlSetFont(-1, 10, 400, 2, 'Arial', 5)
$aidInputGroup[1] = GUICtrlCreateIcon(@ScriptDir & '\gfx\user.ico', 0, 640, 578, 32, 32)
$aidInputGroup[2] = GUICtrlCreateInput('', 680, 580, 260, 32)
GUICtrlSetFont(-1, 18, 800, 0, 'Courier New', 5)
GUICtrlSetLimit(-1, 11)
$aidInputGroup[3] = GUICtrlCreateButton('Ok', 945, 581, 52, 30, $BS_DEFPUSHBUTTON)
GUICtrlSetFont(-1, 10, 600, 0, 'Arial', 5)
GUICtrlCreateGroup('', -99, -99, 1, 1)
_SetInputGroupState($GUI_HIDE)

GUISetState()
_CreateHelp()
Global Const $hGfx = _GDIPlus_GraphicsCreateFromHWND($hPic)
Global Const $hBmp = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGfx)
Global Const $hCtxt = _GDIPlus_ImageGetGraphicsContext($hBmp)
_GDIPlus_GraphicsSetSmoothingMode($hCtxt, 2)
_GDIPlus_GraphicsClear($hCtxt, 0xFF000000)

Global Const $hBrush = _GDIPlus_BrushCreateSolid(0xFF333333)
Global Const $hBrush2 = _GDIPlus_BrushCreateSolid(0xFFF06040)
Global Const $hBrush3 = _GDIPlus_BrushCreateSolid(0xFFEEEE88)

Global Const $hMatrix = _GDIPlus_MatrixCreate()
Global Const $hBmp_Hintergrund = _GDIPlus_BitmapCreateFromFile(@ScriptDir & '\gfx\scheibe.png')
Global Const $hBmp_Rotation = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
Global Const $hCtxt_Rotation = _GDIPlus_ImageGetGraphicsContext($hBmp_Rotation)

Global $aPoints[4][2] = [[3, 0],[$iW2 - 9, $iH2 - 14],[$iW2 + 9, $iH2 - 14],[$iW2 + 0, $iH2 - 170]]
Global $aPoints2[4][2] = [[3, 0],[$iW2 - 5, $iH2 - 16],[$iW2 + 5, $iH2 - 16],[$iW2 + 0, $iH2 - 140]]
Global $aPoints3[4][2] = [[3, 0],[$iW2 - 2, $iH2 - 17],[$iW2 + 2, $iH2 - 17],[$iW2 + 0, $iH2 - 100]]
Global $aFelder[25] = ['Kippe', -1, 50, 10, 25, 1, 100, 0, 50, 10, 25, 1, 100, 0, 50, 10, 25, 1, 100, 0, 50, 10, 25, 1, -2]

Global $f, $ff = 8, $iSegment = 1, $iSegmentOld = 1, $iPower = 0
Drehen($ff)

GUIRegisterMsg($WM_PAINT, 'WM_PAINT')
WinWaitClose($hGui)
Exit

Func _StartPower()
	If $iScoreCount > 9 Then Return
	Local $aInfo = GUIGetCursorInfo($hGui)
	If $aInfo[4] <> $idStart Then Return
	AdlibRegister('_AddPower', 20)
EndFunc   ;==>_StartPower

Func _AddPower()
	$iPower += 1
	If $iPower >= 100 Then $iPower = 100
	GUICtrlSetData($idStartPower, $iPower)
EndFunc   ;==>_AddPower

Func _StopPower()
	If $iScoreCount > 9 Or $iPower = 0 Then
		AdlibUnRegister()
		Return
	EndIf
	Local $aInfo = GUIGetCursorInfo($hGui)
	If $aInfo[4] <> $idStart Then Return
	AdlibUnRegister()
	Btn_Drehen()
EndFunc   ;==>_StopPower

Func Btn_Drehen()
	GUICtrlSetColor($idStartPower, 0x00DD00)
	GUICtrlSetState($idStart, $GUI_DISABLE)
	$f = 15 / 100 * $iPower + Random(5, 6)
	Do
		If $f > 0 Then
			Drehen($f)
			$ff += $f
			If $ff > 360 Then $ff -= 360
			$f -= .02
			$iSegment = Mod(Ceiling($ff / 15), 25)
			If $iSegment <> $iSegmentOld Then
				$f -= Random(0.2, 0.3)
				$iSegmentOld = $iSegment
				If $fSound Then _BASS_ChannelPlay($hClick, 1)
			EndIf
		Else
			$iSegment = Mod(Ceiling($ff / 15), 25)
			If Mod($ff, 15) > 14.45 Or Mod($ff, 15) < 0.55 Then
				$f = 0.6
				ContinueLoop
			EndIf
			Switch $iSegment
				Case 1 ; NULL = alle bisherigen Punkte weg
					If $fSound Then _BASS_ChannelPlay($hBoing, 1)
					_GUICtrlListView_SetItemText($hScoreList, $iScoreCount, 'NULL', 1)
					GUICtrlSetData($idTotalScore, 0)
					$iScore = 0
					_GUICtrlListView_EnsureVisible($hHiScoreList, 99)
					_GUICtrlListView_SetItemSelected($hHiScoreList, 99, False)
				Case 24 ; JACK = Jackpot
					If $fSound Then _BASS_ChannelPlay($hJackpot, 1)
					_GUICtrlListView_SetItemText($hScoreList, $iScoreCount, 'JACK', 1)
					$iScore += 250
				Case 7, 13, 19 ; "0" = keine Punkte
					If $fSound Then _BASS_ChannelPlay($hTok, 1)
					_GUICtrlListView_SetItemText($hScoreList, $iScoreCount, $aFelder[$iSegment], 1)
				Case Else
					_GUICtrlListView_SetItemText($hScoreList, $iScoreCount, $aFelder[$iSegment], 1)
					$iScore += $aFelder[$iSegment]
			EndSwitch
			GUICtrlSetData($idTotalScore, $iScore)
			For $i = 0 To 99
				If $iScore > $aHiScore[$i][1] Then
					_GUICtrlListView_EnsureVisible($hHiScoreList, $i)
					_GUICtrlListView_SetItemSelected($hHiScoreList, $i)
					GUICtrlSetState($idHiScoreList, $GUI_FOCUS)
					ExitLoop
				EndIf
			Next
			$iScoreCount += 1
			$f = 0
			ExitLoop
		EndIf
	Until False * Sleep(25)
	If $iScoreCount < 10 Then
		GUICtrlSetData($idStart, ' Start' & @CRLF & '   Runde ' & $iScoreCount + 1)
		GUICtrlSetState($idStart, $GUI_ENABLE)
	Else
		For $i = 0 To 99
			If $iScore > $aHiScore[$i][1] Then
				If $fSound Then _BASS_ChannelPlay($hNewHiScore, 1)
				_GUICtrlListView_EnsureVisible($hHiScoreList, $i)
				_GUICtrlListView_SetItemSelected($hHiScoreList, $i)
				_SetInputGroupState($GUI_SHOW)
				Opt('GUIOnEventMode', 0)
				Do
				Until GUIGetMsg() = $aidInputGroup[3]
				Opt('GUIOnEventMode', 1)
				_SetInputGroupState($GUI_HIDE)
				Local $sUsername = GUICtrlRead($aidInputGroup[2])
				For $j = 99 To $i + 1 Step -1
					$aHiScore[$j][1] = $aHiScore[$j - 1][1]
					$aHiScore[$j][2] = $aHiScore[$j - 1][2]
				Next
				$aHiScore[$i][1] = $iScore
				$aHiScore[$i][2] = $sUsername
				_GUICtrlListView_DeleteAllItems($hHiScoreList)
				_GUICtrlListView_AddArray($hHiScoreList, $aHiScore)
				_GUICtrlListView_EnsureVisible($hHiScoreList, $i)
				_GUICtrlListView_SetItemSelected($hHiScoreList, $i)
				ExitLoop
			EndIf
		Next
		GUICtrlSetState($idNewGame, $GUI_SHOW)
	EndIf
	$iPower = 0
	GUICtrlSetData($idStartPower, $iPower)
	GUICtrlSetColor($idStartPower, 0x04488FF)
EndFunc   ;==>Btn_Drehen

Func _SetInputGroupState($iState)
	For $i = 0 To UBound($aidInputGroup) - 1
		GUICtrlSetState($aidInputGroup[$i], $iState)
	Next
	GUICtrlSetState($aidInputGroup[2], $GUI_FOCUS)
EndFunc

Func _NewGame()
	GUICtrlSetState($idNewGame, $GUI_HIDE)
	$iScoreCount = 0
	$iScore = 0
	GUICtrlSetData($idTotalScore, 0)
	_GUICtrlListView_BeginUpdate($hScoreList)
	For $i = 0 To 9
		_GUICtrlListView_SetItemText($hScoreList, $i, '', 1)
	Next
	_GUICtrlListView_EndUpdate($hScoreList)
	_GUICtrlListView_EnsureVisible($hHiScoreList, 99)
	_GUICtrlListView_SetItemSelected($hHiScoreList, 99, False)
	GUICtrlSetData($idStart, ' Start' & @CRLF & '   Runde ' & $iScoreCount + 1)
	GUICtrlSetState($idStart, $GUI_ENABLE)
EndFunc   ;==>_NewGame

Func _SoundOnOff()
	$fSound = Not $fSound
	If $fSound Then
		GUICtrlSetImage($idSpeaker, @ScriptDir & '\gfx\speaker1.ico')
	Else
		GUICtrlSetImage($idSpeaker, @ScriptDir & '\gfx\speaker0.ico')
	EndIf
EndFunc

Func _Exit()
	IniWrite($sInifile, 'Config', 'Sound', $fSound)
	_SaveHiScore()
	_BASS_StreamFree($hClick)
	_BASS_StreamFree($hBoing)
	_BASS_StreamFree($hTok)
	_BASS_StreamFree($hJackpot)
	_BASS_StreamFree($hNewHiScore)
	_BASS_Free()
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_BrushDispose($hBrush2)
	_GDIPlus_BrushDispose($hBrush3)
	_GDIPlus_MatrixDispose($hMatrix)
	_GDIPlus_GraphicsDispose($hCtxt)
	_GDIPlus_GraphicsDispose($hCtxt_Rotation)
	_GDIPlus_GraphicsDispose($hGfx)
	_GDIPlus_BitmapDispose($hBmp)
	_GDIPlus_BitmapDispose($hBmp_Rotation)
	_GDIPlus_BitmapDispose($hBmp_Hintergrund)
	_GDIPlus_Shutdown()
	GUIDelete($hGUI)
EndFunc   ;==>_Exit

Func Drehen($fGrad = 0)
	_GDIPlus_GraphicsClear($hCtxt, 0xFF000000)
	_GDIPlus_MatrixTranslate($hMatrix, $iW2, $iH2)
	_GDIPlus_MatrixRotate($hMatrix, $fGrad)
	_GDIPlus_MatrixTranslate($hMatrix, -$iW2, -$iH2)
	_GDIPlus_GraphicsSetTransform($hCtxt_Rotation, $hMatrix)
	_GDIPlus_GraphicsDrawImageRect($hCtxt_Rotation, $hBmp_Hintergrund, 0, 0, $iW, $iH)
	_GDIPlus_GraphicsDrawImageRect($hCtxt, $hBmp_Rotation, 0, 0, $iW, $iH)
	_GDIPlus_GraphicsFillPolygon($hCtxt, $aPoints, $hBrush)
	_GDIPlus_GraphicsFillPolygon($hCtxt, $aPoints2, $hBrush2)
	_GDIPlus_GraphicsFillPolygon($hCtxt, $aPoints3, $hBrush3)
	_GDIPlus_GraphicsDrawImageRect($hGfx, $hBmp, 0, 0, $iW, $iH)
EndFunc   ;==>Drehen

Func _Restore()
	_GDIPlus_GraphicsDrawImageRect($hGfx, $hBmp, 0, 0, $iW, $iH)
EndFunc

Func WM_PAINT($hWnd, $Msg, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImageRect($hGfx, $hBmp, 0, 0, $iW, $iH)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_PAINT

Func _SaveHiScore()
	Local $hFile, $sFile = ''
	For $i = 0 To 99
		$sFile &= $aHiScore[$i][0] & '|' & $aHiScore[$i][1] & '|' & $aHiScore[$i][2] & @CRLF
	Next
	$sFile = StringTrimRight($sFile, 2)
	$hFile = FileOpen($sHiScoreFile, 2)
	If $hFile <> -1 Then
		FileWrite($hFile, $sFile)
		FileClose($hFile)
	EndIf
EndFunc

Func _LoadHiScore()
	Local $sFile = FileRead($sHiScoreFile)
	Local $aRaw = StringSplit($sFile, @CRLF, 3), $aCol
	If UBound($aRaw) <> 100 Then Return _GenerateHiScore()
	For $i = 0 To 99
		$aCol = StringSplit($aRaw[$i], '|', 2)
		If UBound($aCol) <> 3 Then
			$aHiScore[$i][0] = $i + 1
			$aHiScore[$i][1] = 500 - $i * 5
			$aHiScore[$i][2] = 'Computer'
		Else
			$aHiScore[$i][0] = $aCol[0]
			$aHiScore[$i][1] = $aCol[1]
			$aHiScore[$i][2] = $aCol[2]
		EndIf
	Next
EndFunc

Func _GenerateHiScore()
	For $i = 0 To 99
		$aHiScore[$i][0] = $i + 1
		$aHiScore[$i][1] = 500 - $i * 5
		$aHiScore[$i][2] = 'Computer'
	Next
EndFunc

Func _ShowHelp()
	GUISetState(@SW_SHOW, $hHelpGui)
EndFunc   ;==>_ShowHelp

Func _CloseHelp()
	GUISetState(@SW_HIDE, $hHelpGui)
EndFunc   ;==>_CloseHelp

Func _CreateHelp()
	Local $sMsg, $iWidth = 590
	$hHelpGui = GUICreate($sTitle & ' - Hilfe', $iWidth + 20, 270, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION), Default, $hGui)
	GUISetIcon(@ScriptDir & '\gfx\prog.ico')
	GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseHelp', $hHelpGui)
	GUISetBkColor(0xFFFFDD)
	$sMsg = 'Version:   %s\nDatum:    %s'
	GUICtrlCreateLabel(StringFormat($sMsg, $sVersion, $sDate), 80, 15, $iWidth, 40)
	GUICtrlSetFont(-1, 12, 600, 0, 'Verdana')
	$sMsg = 'Autor "Feuerrad": \tThomas Stephan'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 70, 320, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$sLink1 = 'mailto:oscar@elektronik-kurs.de'
	$idAuthor1 = GUICtrlCreateLabel($sLink1, 330, 70, 260, 20)
	GUICtrlSetOnEvent(-1, '_ShowLink')
	GUICtrlSetFont(-1, 10, 400, 4, 'Verdana')
	GUICtrlSetColor(-1, 0x0000FF)
	GUICtrlSetCursor(-1, 0)
	$sMsg = 'Vielen Dank an:  \tUEZ (fr das erstellen des "Glcksrad"-Prototyps)'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 100, 500, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$sMsg = 'Rechtliches:'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 130, $iWidth, 20)
	GUICtrlSetFont(-1, 11, 800, 4, 'Verdana')
	$sMsg = '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n\n'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 160, $iWidth, 60)
	GUICtrlSetFont(-1, 11, 400, 2, 'Verdana')
	GUICtrlCreateButton('Ok', Int($iWidth / 2) - 40, 230, 80, 25, $BS_DEFPUSHBUTTON)
	GUICtrlSetOnEvent(-1, '_CloseHelp')
	GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
EndFunc   ;==>_CreateHelp

Func _ShowLink()
	Switch @GUI_CtrlId
		Case $idAuthor1
			ShellExecute($sLink1)
	EndSwitch
EndFunc   ;==>_ShowLink
